unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls, Grids, TextCal;

type
  TForm1 = class(TForm)
    MyCal: TTextCal;
    FontDialog1: TFontDialog;
    Edit1: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    ComboBox1: TComboBox;
    Label3: TLabel;
    Memo1: TMemo;
    Label4: TLabel;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    SpinButton1: TSpinButton;
    Label5: TLabel;
    Button1: TButton;
    LblMonth: TLabel;
    LblYear: TLabel;
    SpinEdit1: TSpinEdit;
    Label6: TLabel;
    SpinEdit2: TSpinEdit;
    Label7: TLabel;
    Memo2: TMemo;
    Label8: TLabel;
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure MyCalClick(Sender: TObject);
    procedure RadioGroup2Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure MyCalChange(Sender: TObject);
    procedure Memo1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MyCalDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure MyCalDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ComboBox1Change(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MyCalMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Memo2DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure Memo2DragDrop(Sender, Source: TObject; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.SpinButton1DownClick(Sender: TObject);
begin
  MyCal.HeaderRowHeight:=MyCal.HeaderRowHeight+2;
end;

procedure TForm1.SpinButton1UpClick(Sender: TObject);
begin
MyCal.HeaderRowHeight:=MyCal.HeaderRowHeight-2;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  MyCal.ClearStrings;
end;

procedure TForm1.MyCalClick(Sender: TObject);
begin
  Edit1.Text:= DateTimeToStr(MyCal.SelectedDate);
  Edit2.Text:= DateTimeToStr(MyCal.CalendarDate);
  LblMonth.Caption:=LongMonthNames[MyCal.Month];
  LblYear.Caption:=IntToStr(MyCal.Year);
end;

procedure TForm1.RadioGroup2Click(Sender: TObject);
begin
  if RadioGroup2.ItemIndex=0 then
    MyCal.DateBox:=True
  else
    MyCal.DateBox:=False;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  if RadioGroup1.ItemIndex=0 then
    MyCal.AllowMonthChange:=True
  else
    MyCal.AllowMonthChange:=False;
end;

procedure TForm1.MyCalChange(Sender: TObject);
begin
  LblMonth.Caption:=LongMonthNames[MyCal.Month];
  LblYear.Caption:=IntToStr(MyCal.Year);
end;

procedure TForm1.Memo1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then	{ only drag if left button pressed }
    with Sender as TMemo do	{ treat Sender as TFileListBox }
    begin
        BeginDrag(True);	{ if so, drag it }
    end;
end;

procedure TForm1.MyCalDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  if Source is TMemo then
    Accept := True;
end;

procedure TForm1.MyCalDragDrop(Sender, Source: TObject; X, Y: Integer);
var
  MyStrings : TStringList;
  Column, Row: Longint;
begin
  MyCal.MouseToCell(X, Y, Column, Row);
  MyStrings:=TStringList.Create;
  MyStrings.Assign(Memo1.Lines);
  if Source is TMemo then
    MyCal.SetStrings(MyCal.CellDate[Column,Row],MyStrings);
  MyStrings.Free;

end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  if ComboBox1.Text = 'Header' then
  begin
    FontDialog1.Font.Name := MyCal.HeaderFont.Name;
    FontDialog1.Font.Size := MyCal.HeaderFont.Size;
    FontDialog1.Font.Color := MyCal.HeaderFont.Color;
    if FontDialog1.Execute then
      MyCal.HeaderFont := FontDialog1.Font;
  end
  else if ComboBox1.Text = 'Date' then
  begin
    FontDialog1.Font.Name := MyCal.DateFont.Name;
    FontDialog1.Font.Size := MyCal.DateFont.Size;
    FontDialog1.Font.Color := MyCal.DateFont.Color;
    if FontDialog1.Execute then
      MyCal.DateFont := FontDialog1.Font;
  end
  else if ComboBox1.Text = 'OtherDate' then
  begin
    FontDialog1.Font.Name := MyCal.OtherDateFont.Name;
    FontDialog1.Font.Size := MyCal.OtherDateFont.Size;
    FontDialog1.Font.Color := MyCal.OtherDateFont.Color;
    if FontDialog1.Execute then
      MyCal.OtherDateFont := FontDialog1.Font;
  end
  else if ComboBox1.Text = 'Text' then
  begin
    FontDialog1.Font.Name := MyCal.TextFont.Name;
    FontDialog1.Font.Size := MyCal.TextFont.Size;
    FontDialog1.Font.Color := MyCal.TextFont.Color;
    if FontDialog1.Execute then
      MyCal.TextFont := FontDialog1.Font;
  end;

end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
  MyCal.DaysPrior:=SpinEdit1.Value;
end;

procedure TForm1.SpinEdit2Change(Sender: TObject);
begin
  MyCal.DaysPast:=SpinEdit2.Value;
end;

procedure TForm1.FormShow(Sender: TObject);
var
  D,M,Y : word;
begin
  DecodeDate(Date,Y,M,D);
  LblMonth.Caption:=LongMonthNames[M];
  LblYear.Caption:=IntToStr(Y);
end;

procedure TForm1.MyCalMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then
    with Sender as TTextCal do
    begin
        BeginDrag(True);
    end;
end;

procedure TForm1.Memo2DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  if Source is TTextCal then
    Accept := True;
end;

procedure TForm1.Memo2DragDrop(Sender, Source: TObject; X, Y: Integer);
var
  MyStrings : TStringList;
  Column, Row: Longint;
begin
  //MyCal.MouseToCell(X, Y, Column, Row);
  //MyStrings:=TStringList.Create;
 // MyStrings.Assign(Memo1.Lines);
  if Source is TTextCal then
    Memo2.Lines:=MyCal.GetStrings(MyCal.SelectedDate);
end;

end.
